/* 
 Define Constants and Global variables
*/
WiFiClientSecure clientS;	// to connect to a secure (HTTPS) internet server
const int httpsPort = 443;

// constants for time server
const char* hostT = "rjut.nl";

// MAX7221 address bytes / modes of operation
const byte MAX7221_NOOP 			= 0x00;
const byte MAX7221_DIGIT0		= 0x01;
const byte MAX7221_DIGIT1		= 0x02;
const byte MAX7221_DIGIT2		= 0x03;
const byte MAX7221_DIGIT3		= 0x04;
const byte MAX7221_DIGIT4		= 0x05;
const byte MAX7221_DIGIT5		= 0x06;
const byte MAX7221_DIGIT6		= 0x07;
const byte MAX7221_DIGIT7		= 0x08;
const byte MAX7221_DECODEMODE 	= 0x09;
const byte MAX7221_INTENSITY  	= 0x0a;
const byte MAX7221_SCANLIMIT  	= 0x0b;
const byte MAX7221_SHUTDOWN   	= 0x0c;
const byte MAX7221_DISPLAYTEST   = 0x0f;

// MAX7221 values for mode MAX7221_DECODEMODE:
const byte MAX7221_NO_DECODE		= 0x00;
const byte MAX7221_CODEB_DIG0	= 0x01;
const byte MAX7221_CODEB_DIG03	= 0x0F;
const byte MAX7221_CODEB_DIG07	= 0xFF;

// MAX7221 values for mode MAX7221_INTENSITY:
const byte MAX7221_INTENSITY_MIN	= 0x00;
const byte MAX7221_INTENSITY_MAX	= 0x0F;

// MAX7221 values for mode MAX7221_SCANLIMIT:
const byte MAX7221_SCAN_DIG0	= 0x00;
const byte MAX7221_SCAN_DIG01	= 0x01;
const byte MAX7221_SCAN_DIG02	= 0x02;
const byte MAX7221_SCAN_DIG03	= 0x03;
const byte MAX7221_SCAN_DIG04	= 0x04;
const byte MAX7221_SCAN_DIG05	= 0x05;
const byte MAX7221_SCAN_DIG06	= 0x06;
const byte MAX7221_SCAN_DIG07	= 0x07;

// MAX7221 values for mode MAX7221_SHUTDOWN:
const byte MAX7221_SHUTDOWN_ON	= 0x00;
const byte MAX7221_NORMAL_OPER	= 0x01;

// MAX7221 values for mode MAX7221_DISPLAYTEST:
const byte MAX7221_DISPLAY_NORMAL	= 0x00;
const byte MAX7221_DISPLAY_ON		= 0x01;

// MAX7221 mask value for digits in normal operation:
const byte MAX7221_DP_OFF	= 0x00;
const byte MAX7221_DP_ON	= 0x80;

// nr of millisecs in one hour. Can be changed to compensate if internal clock is slow/fast.
const unsigned long HOUR_COUNT = 3600000; 
const byte ButtonHour = 5; 		// D1
const byte ButtonMinute = 4;	// D2
const byte MinIntensityValue = 2;	// intensity for night mode
const byte MaxIntensityValue = 12;	// intensity for day mode

// define  global variables (start with uppercase letter, local variables start with lower case)
String CurrentDate = "2021-02-12";
String CurrentTime = "00:00";
byte CurrentMonth = 0;
byte ClockHour = 12;
byte ClockMin = 0;
byte ClockSec = 0;
unsigned long updateClockMillis = 0;
unsigned long fetchTimeMillis = 0;
bool TimeServerData = false;
