/* 
 SETUP sketch
*/
void setup() {
	// the spi library sets the MOSI and CLK outputs
	// set pin for slave select output (not used by SPI library)
	pinMode(SS, OUTPUT);

	// input for hour + button
	pinMode(ButtonHour, INPUT_PULLUP);
	// input for minute + button
	pinMode(ButtonMinute, INPUT_PULLUP);

	// activate debug monitor
	Serial.begin(115200);

	SPI.begin();
	SPI.beginTransaction(SPISettings(1000000, MSBFIRST, SPI_MODE0));
	
	// All LED segments should light up
	maxTransfer(MAX7221_DISPLAYTEST, MAX7221_DISPLAY_ON);
	delay(1000);
	maxTransfer(MAX7221_DISPLAYTEST, MAX7221_DISPLAY_NORMAL);
	// Set decode mode B for digits 0-3
	maxTransfer(MAX7221_DECODEMODE, MAX7221_CODEB_DIG03);
	// Set intensity
	maxTransfer(MAX7221_INTENSITY, MAX7221_INTENSITY_MAX);
	// Only use digits 0-3
	maxTransfer(MAX7221_SCANLIMIT, MAX7221_SCAN_DIG03);
	// Turn on chip
	maxTransfer(MAX7221_SHUTDOWN, MAX7221_NORMAL_OPER);
	// Blank the clock
	maxTransfer(MAX7221_DIGIT3,0x0F);
	maxTransfer(MAX7221_DIGIT2,0x0F);
	maxTransfer(MAX7221_DIGIT1,0x0F);
	maxTransfer(MAX7221_DIGIT0,0x0F);

	// Connect to local WiFi-netwerk
	connectLocalWiFi();
}
