/* 
 LOOP sketch
*/
void loop() { 
	if (updateClockMillis ==0) {			// compensate for initial millis() passed during startup
		fetchTimeMillis = millis()-1;		// make sure time is fectched at startup + clock is updated
		updateClockMillis = 30000 + fetchTimeMillis;	// offset between time fetch and clock update
	}

// this section is processed every hour.
	if ( (millis() > fetchTimeMillis) && (WiFi.status() == WL_CONNECTED) ) {
		getLocalDateTime();
		if (TimeServerData) {
			CurrentMonth = CurrentDate.substring(5,7).toInt();
			ClockHour = CurrentTime.substring(0,2).toInt();
			ClockMin = CurrentTime.substring(3,5).toInt();
			ClockSec = CurrentTime.substring(6,8).toInt();
			// set minute marker to update clock on ~00 second
			updateClockMillis += 1000*(30 - ClockSec);	// use 30 to compensate diff time fetch and clock update
			// write current time to display
			updateDisplay();
			// set hour marker to update on 30 sec after an hour
			fetchTimeMillis = updateClockMillis + HOUR_COUNT - 30000;
		} else {
			// set hour marker to update on 30 sec after an hour (after time data fail)
			fetchTimeMillis = updateClockMillis + HOUR_COUNT - 30000;
		}
	}
	
// this section is processed every minute.
	if (millis() > updateClockMillis) {
		// step the clock one min
		ClockMin++;
		if (ClockMin>59) {
			ClockMin = 0;
			ClockHour++;
			if (ClockHour>23) ClockHour=0;
		}
		// write time to display
		updateDisplay();
		// set marker for next min update
		updateClockMillis += (HOUR_COUNT / 60);
		// try to reconnect to local WiFi if connection was lost
		if (WiFi.status() != WL_CONNECTED) connectLocalWiFi();
	}

// this section is processed every loop cycle 

	// check if HOUR button is pressed
	if (digitalRead(ButtonHour)==LOW) {
		ClockHour++;
		if (ClockHour>23) ClockHour=0;
		updateDisplay();
		delay(500);
	}

	// check if MINUTE button is pressed
	if (digitalRead(ButtonMinute)==LOW) {
		ClockMin++;
		if (ClockMin>59) ClockMin=0;
		updateDisplay();
		updateClockMillis = millis() + (HOUR_COUNT / 60);
		fetchTimeMillis = updateClockMillis + HOUR_COUNT - 30000;
		delay(300);
	}
}
